// ComputeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ThreadSimple.h"
#include "ComputeDlg.h"
#include ".\computedlg.h"
#include <afxmt.h>

CEvent threadStartCompute;
CEvent threadEndCompute;

#define WM_THREADFINISHED WM_USER+11

volatile int g_nCount = 0;
// CComputeDlg dialog

IMPLEMENT_DYNAMIC(CComputeDlg, CDialog)
CComputeDlg::CComputeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComputeDlg::IDD, pParent)
{
}

CComputeDlg::~CComputeDlg()
{
}

void CComputeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CComputeDlg, CDialog)
	ON_WM_TIMER()
	ON_MESSAGE(WM_THREADFINISHED, OnThreadFinished)
END_MESSAGE_MAP()


// CComputeDlg message handlers

UINT ComputeThreadProc(LPVOID param) {
	volatile int nTemp, nCount;
	::WaitForSingleObject(threadStartCompute.m_hObject, INFINITE);
	TRACE("Started\n");
	bool bThreadController = true;
	//int g_nCount;
	for (g_nCount = 0; 
		 bThreadController && g_nCount < CComputeDlg::nMaxCount;
		 g_nCount++) 
	{
		for (nTemp = 0; nTemp < 10000; nTemp++) {
		}
			;
		bThreadController = 
			::WaitForSingleObject(threadEndCompute.m_hObject, 0) != WAIT_OBJECT_0;
	}
	::PostMessage((HWND) param, WM_THREADFINISHED, 0, 0);
	return 0;
}


void CComputeDlg::OnTimer(UINT nIDEvent)
{
	CProgressCtrl *pBar = (CProgressCtrl*) GetDlgItem(IDC_PROGRESS1);
	pBar->SetPos(g_nCount * 100 / nMaxCount);
}

void CComputeDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class
	threadEndCompute.SetEvent();
	CDialog::OnCancel();
}

void CComputeDlg::OnOK()
{
	AfxBeginThread(ComputeThreadProc, GetSafeHwnd(),
		THREAD_PRIORITY_NORMAL);
	threadStartCompute.SetEvent();
	// TODO: Add your specialized code here and/or call the base class
	int nTimer = SetTimer(1, 100, NULL);
	ASSERT(nTimer != 0);
	((CButton*)GetDlgItem(IDOK))->EnableWindow(FALSE);
	CRect rect;
	this->SetFocus();
	this->GetWindowRect(&rect);
	this->SetWindowPos(&wndTopMost, 
		rect.left, rect.top, rect.Width(), rect.Height(), 
		SWP_SHOWWINDOW);
}

LRESULT CComputeDlg::OnThreadFinished(WPARAM wParam, LPARAM lParam)
{
	CDialog::OnOK();
	return 0L;
}

BOOL CComputeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
